##############################
### ROZDZIAL 3 ###############
##############################
### REGRESJA KWANTYLOWA ######
##############################
### (C) Marcin Pietrzak ######
##############################

#######################
# INSTALACJA PAKIETW #
#######################
install.packages("tseries", "quantreg", "fBasics")
library(tseries)
library(quantreg)
library(fBasics)

#####################################################
# TRANSFORMACJA DANYCH I SPRAWDZENIE STACJONARNOSCI #
#####################################################
setwd("C:/zastosowania_ekonometrii_www/03/")
Dane <- read.table("rozdzial_3.txt", header = TRUE, dec = ",", quote = "\"")
FW20 <- diff(log(Dane$FW20))
KGH <- diff(log(Dane$KGH))
windows()
par(mfrow = c(2,2))
plot(Dane$FW20,type = 'l', main = "Kontrakt terminowy
     na WIG20", xlab = "", ylab = "")
plot(Dane$KGH,type = 'l', main = "Cena akcji
     KGHM", xlab = "", ylab = "")
plot(FW20,type = 'l', main = "Dzienne stopy zwrotu 
     kontraktu terminowego na WIG20", , xlab = "Czas", ylab = "")
plot(KGH,type = 'l', main = "Dzienne stopy zwrotu akcji
     KGHM", xlab = "Czas", ylab = "")
kpss.test(FW20)
kpss.test(KGH)
adf.test(FW20)
adf.test(KGH)

#############
# ESTYMACJA #
#############
m <- .95 # Budujemy model dla m-tej czci prby, a sprawdzamy dla 1-m
m <- floor(m*length(FW20)) 
ols <- lm(KGH[1:m] ~ FW20[1:m])
summary(ols)
tau <- c(.1, .2, .3, .4, .5)
rq <- rq(KGH[1:m] ~ FW20[1:m], tau)
summary(rq)
summary(KGH)
rq1 <- rq(KGH[1:m] ~ FW20[1:m], tau = 1:10/20)
windows()
par(mfrow = c(1, 2))
plot(1:10 / 20, unname(coef(rq1)[1, ]), type = 'l', main = "Staa", xlab=expression(tau), 
     ylab="")
plot(1:10 / 20, unname(coef(rq1)[2, ]), type = 'l', main = "Wspczynnik", xlab=expression(tau), ylab = "")

########################
# SPRAWDZENIE HEDGINGU #
########################
h <- rep(0, (1 + length(tau)))
h[1] <- unname(coef(ols)[2])
h[-(1)] <- unname(coef(rq)[2, ])
zwrot <- KGH[- (1:m)] - FW20[- (1:m)] %*% t(h)
odchyl <- colSds(zwrot)
srednia <- colMeans(zwrot)
windows()
plot(srednia, odchyl, main = "rednia stopa zwrotu a jej zmienno", 
     xlab = "rednia stopa zwrotu ", ylab = "Odchylenie standardowe", pch = 19,
     xlim = c(min(srednia) * 1.01, max(srednia) * 1), ylim = c(min(odchyl) * 0.999,
     max(odchyl) * 1.003))
text(srednia, odchyl, labels = c("MNK", expression(tau ~ "= 0.1"),
     expression(tau ~ "= 0.2"), expression(tau ~ "= 0.3"),
     expression(tau ~ "= 0.4"), expression(tau ~ "= 0.5")), cex = 0.7, pos = 3)
