##############################
### ROZDZIAL 5 ###############
##############################
### Testy LM i F #############
##############################
### (C) Justyna Klejdysz #####
##############################

setwd("C:/zastosowania_ekonometrii_www/05")

install.packages("car")
install.packages("lmtest")
library("car")
library("lmtest")

wino <- read.csv(file = "rozdzial_5.csv", head = TRUE, sep = ";")
wino.lm <- lm(log(PRICE) ~ VINT + WRAIN + STEMP + HTEMP + HRAIN, data = wino)
summary(wino.lm)

#Test liniowych restrykcji
linearHypothesis(wino.lm, c("HRAIN = 0", "HTEMP = 0"))

#wykluczamy z modelu zmienn HTEMP
wino.lm <- lm(log(PRICE) ~ VINT + WRAIN + STEMP + HRAIN, data = wino)
#Test BG na autokorelacj do drugiego rzdu wcznie
wino.bg <- bgtest(lm(log(PRICE) ~ VINT + WRAIN + STEMP + HRAIN, data = wino), order = 2)
wino.bg

#reszty z modelu zredukowanego (bez zmiennych HRAIN i HTEMP)
restrict.res <- resid(lm(log(PRICE) ~ VINT + WRAIN + STEMP, data = wino))
#regresja pomocnicza (auxiliary regression)
aux1.lm <- lm(restrict.res ~ VINT + WRAIN + STEMP + HRAIN + HTEMP, data = wino)
#warto statystyki LM i p-value
LMstat<-summary(aux1.lm)$r.squared * nobs(aux1.lm)
p.value <- 1 - pchisq(LMstat, 2) 
p.value

wino.lm <- lm(log(PRICE) ~ VINT + WRAIN + STEMP + HRAIN, data=wino)
#reszty modelu (bez zmiennej HTEMP)
wino.res <- resid(wino.lm)
#opnienia reszt:
lag1.res <- c(NA, wino.res)[1:length(wino.res)]     #reszty t-1
lag2.res <- c(NA, NA, wino.res)[1:length(wino.res)] #reszty t-2
#regresja pomocnicza
aux2.lm <- lm(wino.res ~ wino$VINT + wino$WRAIN + wino$STEMP 
+ wino$HRAIN + lag1.res + lag2.res)

LMstat <- summary(aux2.lm)$r.squared * nobs(aux2.lm)
p.value <- 1 - pchisq(LMstat, 2) 
p.value # porwnajmy wynik z bgtest(wino.lm)- Tabela 10.2.   

linearHypothesis(aux2.lm, c("lag1.res = 0", "lag2.res = 0"))    

unrestr.lm <- lm(log(wino$PRICE) ~ wino$VINT  + wino$WRAIN + wino$STEMP + wino$HRAIN + lag1.res + lag2.res)
linearHypothesis(unrestr.lm,c("lag1.res = 0", "lag2.res = 0")) 

#Model pomocniczy i test LM przy zaoeniu sabej egzogenicznoci zmiennych:
weak.egz <- lm(wino.res ~ wino$WRAIN + wino$STEMP + 
+ wino$HRAIN + wino$VINT + lag1.res + lag2.res)
#Model pomocniczy i test LM przy zaoeniu cisej egzogenicznoci zmiennych:
strict.egz <- lm(wino.res ~ lag1.res + lag2.res)
summary(weak.egz)
summary(strict.egz)
wLMstat <- summary(weak.egz)$r.squared * nobs(weak.egz)
sLMstat <- summary(strict.egz)$r.squared * nobs(strict.egz)
1 - pchisq(sLMstat, 2) 
1 - pchisq(wLMstat, 2)
